<template>
    <div class="container-fluid">
        <div class="title-nav">
            <img src="../assets/trainerin.png" alt="" class="titel-logo" >
        </div>
        <div class="card-container" @submit.prevent="postTrainerIn">
            <div class="card-head">
                <div class="container-fluid">
                    <div class="row gx-1 justify-content-between">
                        <div class="col-lg-1 col-md-3 arrow-container">
                            <span id="arrowclick" class="accordion-arrow "  v-class:open="dreh" @click="toggleState" type="button" data-bs-toggle="collapse" data-bs-target="#collapseExample" aria-expanded="false" aria-controls="collapseExample">
                                &#9654;
                            </span>
                        </div>

                        <div class="col-lg-2 col-md-3">
                            <form><input type="text"  v-model="neueTrainerIn.name" placeholder="Name" /></form>
                        </div>

                        <div class="col-lg-2 col-md-3">
                            <form><input type="text" v-model="neueTrainerIn.emailAdresse" placeholder="Email"></form>
                        </div>

                        <div class="col-lg-2 col-md-3">
                            <form ><input type="text" v-model="neueTrainerIn.telefon" placeholder="Telefon"></form>
                        </div>

                        <div class="col-lg-2 col-md-3">
                            <form >
                                <select name="fw" v-model="neueTrainerIn.fachwissen">
                                    <option disabled >Fachwissen</option>
                                    <option value="WEB">Web</option>
                                    <option value="JAVA">Java</option>
                                    <option value="OS">OS</option>
                                    <option value="NETZWERKTECHNIK">Netzwerktechnik</option>
                                    <option value="KARRIERECOACHING">Karrierecoaching</option>
                                </select>
                                <!-- <input type="text" v-model="fachwissen" placeholder="Fachwissen"> -->
                            </form>
                        </div>

                        <div class="col-lg-2 col-md-3">
                            <form >
                                <select name="vb" v-model="neueTrainerIn.verfuegbarkeit">
                                    <option disabled selected>Verfügbarkeit</option>
                                    <option value="MONTAG">Montag</option>
                                    <option value="DIENSTAG">Dienstag</option>
                                    <option value="MITTWOCH">Mittwoch</option>
                                    <option value="DONNERSTAG">Donnerstag</option>
                                    <option value="FREITAG">Freitag</option>
                                </select>
                            </form>
                            
                        </div>
                        <div class="col-lg-1 col-md-3 add-del-container">
                            <div class="plus-container" >
                                <span class="plus" @click="postTrainerIn(neueTrainerIn)">+</span>
                            </div>
                            
                        </div>
                </div>
            </div>
        </div>
            <div class="collapse" id="collapseExample">
                <div class="card card-body">
                    <div class="container">
                        <div class="row gx-1 justify-content-between">
                            <div class="col-lg-1 col-md-3">
                                
                            </div>
                            <div class="col-lg-2 col-md-3">
                                
                                <form><input id="startDate" class="form-control" type="date" v-model="neueTrainerIn.geburtstag" /></form>
                            </div>

                            <div class="col-lg-2 col-md-3">
                                <form><input type="text" v-model="neueTrainerIn.adresse" placeholder="Adresse"></form>
                            </div>

                            <div class="col-lg-2 col-md-3">
                                <form >
                                    <select name="vb" v-model="neueTrainerIn.beschaeftigung">
                                        <option disabled selected>Beschäftigung</option>
                                        <option value="VOLLZEIT">Vollzeit</option>
                                        <option value="TEILZEIT">Teilzeit</option>
                                        <option value="SELBSTSTÄNDIG">Selbstständig</option>
                                    </select>
                                </form>
                            </div>

                            <div class="col-lg-2 col-md-3">
                                <form><input type="text" v-model="neueTrainerIn.bruttolohn" placeholder="Bruttolohn"></form>
                            </div>
                            <div class="col-lg-1 col-md-3">
                                
                            </div>
                        </div>
                    </div>
                </div>
            </div> 
        </div>

        <!-- Alle TrainerInnen -->
        <div class="card-container alle-trainerinnen trainerset"  v-for="(trainerIn, id) in alleTrainerInnen" :key="id" @submit.prevent="manipTrainerIn(trainerIn)">
            <div class="card-head">
                <div class="container-fluid">
                    <div class="row gx-1 justify-content-between">
                        <div class="col-lg-2 col-md-3 arrow-container">
                            <span :id="'arrowclick'+trainerIn.id" class="accordion-arrow " type="button"  data-bs-toggle="collapse" :data-bs-target="'#flush-collapse'+trainerIn.id" aria-expanded="false" :aria-controls="'#flush-collapse'+trainerIn.id" v-class:open="dreh" v-class:closed="!dreh" @click="toggleState">
                                &#9654;
                            </span>
                            <span class="floppy" @click="manipTrainerIn(trainerIn)">&#128427;</span>
                        </div>

                        <div class="col-lg-2 col-md-3">
                            <div class="title-trainerinnen-container"><span class="col-titles">Name</span></div>
                            <form><input type="text"  v-model="trainerIn.name" placeholder="Name" /></form>
                        </div>

                        <div class="col-lg-2 col-md-3 email-input">
                            <span class="col-titles">Email</span>
                            <form><a :href="'mailto:'+trainerIn.emailAdresse" target="_blank" class="mail">&#9993;</a> <input type="text" v-model="trainerIn.emailAdresse" placeholder="Email"></form>
                        </div>

                        <div class="col-lg-2 col-md-3">
                            <span class="col-titles">Telefon</span>
                            <form ><input type="text" v-model="trainerIn.telefon" placeholder="Telefon"></form>
                        </div>

                        <div class="col-lg-2 col-md-3">
                            <span class="col-titles">Fachwissen</span>
                            <form >
                                <select name="fw" v-model="trainerIn.fachwissen">
                                    <option value="" disabled selected>Fachwissen</option>
                                    <option value="WEB">Web</option>
                                    <option value="JAVA">Java</option>
                                    <option value="OS">OS</option>
                                    <option value="NETZWERKTECHNIK">Netzwerktechnik</option>
                                    <option value="KARRIERECOACHING">Karrierecoaching</option>
                                </select>
                            </form>
                        </div>

                        <div class="col-lg-2 col-md-3">
                            <span class="col-titles">Verfügbarkeit</span>
                            <form >
                                <select name="vb" v-model="trainerIn.verfuegbarkeit">
                                    <option  disabled>Verfügbarkeit</option>
                                    <option value="MONTAG">Montag</option>
                                    <option value="DIENSTAG">Dienstag</option>
                                    <option value="MITTWOCH">Mittwoch</option>
                                    <option value="DONNERSTAG">Donnerstag</option>
                                    <option value="FREITAG">Freitag</option>
                                </select>
                            </form>
                            
                        </div>
                        <div class="col-lg-2 col-md-3 add-del-container">
                            <div class="minus-container">
                                <span class="minus"  @click="deleteTrainerIn(trainerIn.id)">-</span>
                            </div>
                            
                        </div>
                </div>
            </div>
        </div>
            <div class="collapse"  :id="'flush-collapse'+trainerIn.id" :aria-labelledby="'flush-heading'+trainerIn.id" data-bs-parent="#accordionFlushExample">
                <div class="card card-body card-body-settings">
                    <div class="container-fluid">
                        <div class="row gx-1 justify-content-between">
                            <div class="col-lg-2 col-md-3 arrow-container">
                                
                            </div>
                            <div class="col-lg-2 col-md-3">
                                <div class="title-trainerinnen-container"><span class="col-titles">Geburtstag</span></div>
                                <form><input type="text" v-model="trainerIn.geburtstag" placeholder="Geburtstag"></form>
                            </div>

                            <div class="col-lg-2 col-md-3">
                                <div class="title-trainerinnen-container"><span class="col-titles">Adresse</span></div>
                                <form><input type="text" v-model="trainerIn.adresse" placeholder="Adresse"></form>
                            </div>

                            <div class="col-lg-2 col-md-3">
                                <div class="title-trainerinnen-container"><span class="col-titles">Beschäftigung</span></div>
                                <form >
                                    <select name="vb" v-model="trainerIn.beschaeftigung">
                                        <option value="" disabled selected>Beschäftigung</option>
                                        <option value="VOLLZEIT">Vollzeit</option>
                                        <option value="TEILZEIT">Teilzeit</option>
                                        <option value="SELBSTSTÄNDIG">Selbstständig</option>
                                    </select>
                                </form>
                            </div>

                            <div class="col-lg-2 col-md-3">
                                <div class="title-trainerinnen-container"><span class="col-titles">Bruttolohn</span></div>
                                <form><input type="text" v-model.number="trainerIn.bruttolohn" placeholder="Bruttolohn"></form>
                            </div>
                            <div class="col-lg-2 col-md-3">
                                <div class="title-trainerinnen-container"><span class="col-titles">Nettolohn</span></div>
                                <form><input type="text" v-model="trainerIn.nettolohn" placeholder="Nettolohn"></form>
                            </div>
                            <div class="col-lg-2 col-md-3 add-del-container">
                               
                            </div>
                        </div>
                    </div>
                </div>
            </div> 
        </div>

        
            
        
    </div>
</template>

<script>


    export default{
        data() {  
            return {
                trainerInnenUpdate: {
                    name: "",
                    emailAdresse: "",
                    telefon: "",
                    fachwissen: "",
                    verfuegbarkeit: "",
                    geburtstag: "",
                    bruttolohn: "",
                    nettolohn: "",
                    adresse: "",
                    beschaeftigung: "",
                    id: "",
                },
                neueTrainerIn: {
                    name: null,
                    emailAdresse: null,
                    telefon: null,
                    fachwissen: "Fachwissen",
                    verfuegbarkeit: "Verfügbarkeit",
                    geburtstag: null,
                    bruttolohn: '',
                    nettolohn:'',
                    adresse: null,
                    beschaeftigung: "Beschäftigung",
                }, 
                dreh: false,
            };
        },
        computed: {
            alleTrainerInnen() {
                return this.$store.state.alleTrainerInnen;
            },
            trainerInnenById() {
                return this.$store.state.trainerInnenById;
            },
        },
        methods: {
            toggleState() {
                this.dreh = !this.dreh;
            },
            postTrainerIn(){
                console.log(this.postTrainerIn)
                const response = this.$store.dispatch('postTrainerIn', this.neueTrainerIn)
                .then((result) => {
                    console.log(result)
                    console.log(response)
                })
                this.$store.commit("unshiftAlleTrainerInnen", this.neueTrainerIn)

                this.neueTrainerIn = {
                    name: null,
                    emailAdresse: null,
                    telefon: null,
                    fachwissen: "Fachwissen",
                    verfuegbarkeit: null,
                    geburtstag: null,
                    bruttolohn: '',
                    nettolohn:'',
                    adresse: null,
                    beschaeftigung: "Beschäftigung",
                }
                
            },
            async getTrainerInnenById(id) {
                this.$store.dispatch("getTrainerInnenById", id);
            },
            async deleteTrainerIn(id) {
                const deleteTrainerIn = this.$store.dispatch("deleteTrainerIn", id);
                console.log(deleteTrainerIn);
            },
            async manipTrainerIn(trainerInnenById) {
                this.trainerInnenUpdate.name = trainerInnenById.name;
                this.trainerInnenUpdate.emailAdresse = trainerInnenById.emailAdresse;
                this.trainerInnenUpdate.telefon = trainerInnenById.telefon;
                this.trainerInnenUpdate.fachwissen = trainerInnenById.fachwissen;
                this.trainerInnenUpdate.verfuegbarkeit = trainerInnenById.verfuegbarkeit;
                this.trainerInnenUpdate.geburtstag = trainerInnenById.geburtstag;
                this.trainerInnenUpdate.adresse = trainerInnenById.adresse;
                this.trainerInnenUpdate.beschaeftigung = trainerInnenById.beschaeftigung;
                this.trainerInnenUpdate.bruttolohn = trainerInnenById.bruttolohn;
                this.trainerInnenUpdate.nettolohn = trainerInnenById.nettolohn;
                this.trainerInnenUpdate.id = trainerInnenById.id;
                this.$store.dispatch("putTrainerIn", this.trainerInnenUpdate);
            },
            async putTrainerIn() {
                const response = this.$store.dispatch("putTrainerIn", this.trainerInnenUpdate);
                console.log(response);
                console.log(this.trainerInnenUpdate);
            }
        },
        mounted() {
            this.$store.dispatch("getAlleTrainerInnen");
        },

};    

</script>

